/******************************************************************************
ºݤΥåˤؿ
******************************************************************************/

#include <stdio.h>
#include <string.h>		/* strcpy, strlen */
#include <limits.h>		/* INT_MAX */
#include "tx.h"

char usr[MAXLIN][MAXCOL + 1];			/* 桼Ϥ */

void evaluate(char *tt, char *uu);		/* ΥեγϸƤФʤ */

void start_prompt(void);				/* δؿ lesson2.c ˤ */
void user_input(char* u);
void end_prompt(void);


/******************************************************************************
ڴؿ̾	Lesson_init
ڵǽ	ʸޤΥեɤ߹ࡣ
ڰ	ʤ
͡	ʤ
******************************************************************************/
void Lesson_init(void) {
	int i;
	FILE* in;

	if ((in = fopen(figfname, "r")) == NULL) {
		ending("ޤΥե%sפץǤޤ.", figfname);
	}

		/* ɤ߹߻֤ꤹƥ桼ۤʾ */
		/* ǥåФȤ褤							*/

	for (i = 0; i < MAXFIGURENUM; i++) {
		if (feof(in)) {
			goto next;							/* Ǹޤɤ᤿ */
		}
		figptr[i] = Figure_read(in);
	}
	ending("ޤΥե%sפΡޤο¿ޤ.", figfname);

next:

	fclose(in);

	if ((in = fopen(txtfname, "r")) == NULL) {
		ending("ʸΥե%sפץǤޤ.", txtfname);
	}

		/* ɤ߹߻֤ꤹƥ桼ۤʾ */
		/* ǥåФȤ褤							*/

	for (i = 1; i < MAXLESSONNUM; i++) {
		if (feof(in)) {
			goto next2;							/* Ǹޤɤ᤿ */
		}
		txtptr[i] = Text_read(in, i);
	}
	ending("ʸΥե%sפΡݤο¿ޤ.", txtfname);

next2:

	lastlessonnum = i-1;
	fclose(in);
} /* Lesson_init */


/******************************************************************************
ڴؿ̾	Lesson_show
ڵǽ	å򸫤롣
ڰ	ʤ
͡	ʤ
******************************************************************************/
void Lesson_show(void) {
	int i, j;
	Text* t;

	if (lessonnum > lastlessonnum) {
		ending("βݤֹ椬۾Ǥ.", NULL);
	}

	t = txtptr[lessonnum];

	strcpy(lessonname, t->textname);
	xgotoxy(1, 3);							/* å̾ɽϰ */
	xprintf("%-22s", t->textname);			/* å̾ɽ */

#ifdef PC98
	showmenu("return    ESC λ    ʤ    ");
#else /* not PC98 */
	showmenu("Enter    ESC λ    ʤ    ");
#endif /* not PC98 */

	if (t->figurename[0] != '\0') {			/* ޤɽ */
		Figure_show(t->figurename);
	}

	j = line;
	for (i = 0; i < LINES - 5 && t->string[i] != NULL; i++) {
		xgotoxy(j, 1); j++;					/* ư */
		xprintf("%s", t->string[i]);		/* Ϥʸɽ */
		xclr2end();							/* ޤǥꥢ */
	}

	line = j;
	for (i = 0; i < MAXLIN && t->txt[i] != NULL; i++) {
		xgotoxy(j, 1);						/* ư */
		xcolor4text1();						/* ʸɽ */
		xprintf("%s", t->txt[i]);			/* ʸɽ */
		xcolornormal();						/* ǥեȿ */
		xclr2end();							/* ޤǥꥢ */
		j++;
		xgotoxy(j, 1);						/* ʸβιԤϾõ */
		xclr2end();
		j++;
	}

	for (i = j; i <= LINES - 3; i++) {		/* Ĥʬξõ */
		xgotoxy(i, 1);
		xclr2end();							/* ޤǥꥢ */
	}
											/* ɸɽ */
	if (t->txt[0] != NULL) {
		char tmp[128];
		Myfloat tmps;

		errorlim = t->errorlim;
		Myfloat_sprintf(str_errorlim, errorlim);

		xgotoxy(LINES - 1, 1);
		xprintf("ɸա顼Ψ %3s %% ̤", str_errorlim);
		xclr2end();

		for (i = 1; i < lessonnum; i++) {
			if (txtptr[i]->isclear == 'x') {
				xgotoxy(LINES - 1, 36);
				xcolor4no();
				xprintf("βݰ̤ʤβݤޤ.");
				xclr2end();
			}
		}

		xgotoxy(LINES - 1, 71);
		if (t->isclear == 'x') {
			xcolor4no();
			xprintf("̤");
		} else if (t->isclear == 'o') {
			xcolor4ok();
			xprintf("ʺ");
		}
		xcolornormal();
		xclr2end();

		timelim = t->timelim;
		Myfloat_sprintf(str_timelim, timelim);

		xgotoxy(LINES - 0, 1);
		xprintf("          ÿ/(ǿ-%dx顼) %5s ̤",
					penalty, str_timelim);
		Myfloat_init(&tmps, 12, 1, 1);
		Myfloat_sprintf(tmp, Myfloat_div(tmps, timelim, 1));
		xprintf("  (i.e. 1ʬ %s ɰʾ)", tmp);
		xclr2end();
	} else {
		copyright();
	}
} /* Lesson_show */


/******************************************************************************
ڴؿ̾	Lesson_next
ڵǽ	βݤؿʤࡣ
ڰ	ʤ
͡	ʤ
******************************************************************************/
void Lesson_next(void) {
	if (lessonnum < lastlessonnum) {
		lessonnum++;
	} else {
		bell();
	}
} /* Lesson_next */


/******************************************************************************
ڴؿ̾	Lesson_prev
ڵǽ	βݤ롣
ڰ	ʤ
͡	ʤ
******************************************************************************/
void Lesson_prev(void) {
	if (lessonnum != 1) {
		lessonnum--;
	} else {
		bell();
	}
} /* Lesson_prev */


/******************************************************************************
ڴؿ̾	Lesson_practice
ڵǽ	򤵤롣
ڰ	ʤ
͡	ʤ
******************************************************************************/
void Lesson_practice(void) {
	int i;
	unsigned long tmp_time;
	Text* tptr = txtptr[lessonnum];

	strokes = 0;					 /* ȥΥ */
	for (i = 0; i < MAXLIN && tptr->txt[i]; i++) {
		strokes += strlen(tptr->txt[i]);
	}

	if (strokes == 0) {				/* ʸΤʤݤ褦Ȥ */
		bell();						/* ٥Ĥ餷֤ */
		return;
	}

	errors = 0;							/* 顼򥯥ꥢ */
	your_strokes = 0;					/* 桼ȥ򥯥ꥢ */
	errorlim = tptr->errorlim;			/* ɸ顼Ψ򥻥å */
	timelim = tptr->timelim;			/* ɸ򥻥å */

	xgotoxy(1, 1);					/* ϰ֤إư */
	start_prompt();						/* ϥץץ */

	starttime = time(NULL);				/* ϻϿ */

#ifndef LINUX
	xgotoxy(line, 1);			/* ϰ֤إư */
#endif

	for (i = 0; i < MAXLIN && tptr->txt[i]; i++) {
#ifdef LINUX
	    xgotoxy(line + 2 * i, 1);		/* ϰ֤إư */
#endif
		user_input(usr[i]);				/* 桼 */
		your_strokes += strlen(usr[i]);	/* ǿ򥫥 */
		xgotoxy(line + 2 * i, 1);
		xcolor4text0();					/* ʸΰˤ */
		xprintf(tptr->txt[i]);			/* ʸΰ */
		xcolornormal();					/* ǥեȿ᤹ */
	}

	endtime = time(NULL);					/* λϿ */

	tmp_time  = struct_tm2sec(gmtime(&endtime));
	tmp_time -= struct_tm2sec(gmtime(&starttime));

											/* ׻֤Ͽ */
	if (tmp_time <= INT_MAX) {
		seconds = (int) (tmp_time);
	} else {
		seconds = INT_MAX;
	}

	for (i = 0; i < MAXLIN && tptr->txt[i]; i++) {		/* ʸɽ */
		xgotoxy(line + 2 * i, 1);
		xcolor4text1();					/* ʸɽѤοѹ */
		xprintf(tptr->txt[i]);			/* ⤦١ʸɽ */
		xcolornormal();					/* Ρޥο᤹ */
		xgotoxy(line + 2 * i + 1, 1);
		evaluate(tptr->txt[i], usr[i]);	/* ̤βɽ */
		xclr2end();						/* ޤǺ */
	}

	if (Score_write() == OK) {			/* ̤βɽǥ񤭹 */
		tptr->isclear = 'o';
	}

	end_prompt();						/* Ĥνλץץ */

	return;
} /* Lesson_practice */



enum VECS { END = 0x00, \
			COR = 0x01, WRG = 0x02, INS = 0x04, DRP = 0x08, XCH = 0x10 };

/******************************************************************************
ڴؿ̾	evaluate()
ڵǽ	ĤʸӤ̤ err[][] ˳Ǽӷ̤β̽ϡ
ڰ	Ĥʸ
͡	ʤ
ա	ĤʸӡפȤǽϤˤѤǤ뤬¤Ϥޤ
			ѤΥ롼ǤϤʤΤդ衣:-)
******************************************************************************/
void evaluate(char *t, char *u) {
	int i, j;
	int tlen, ulen;

	static char err[MAXCOL+1][MAXCOL+1];
	static char cmp[MAXCOL+1][MAXCOL+1];
	static char cor[MAXCOL+1][MAXCOL+1];
	static char vec[MAXCOL+1][MAXCOL+1];

	tlen = strlen(t);
	ulen = strlen(u);

	err[tlen][ulen] = 0;				/* Ƚɤ */
	cmp[tlen][ulen] = 0;
	cor[tlen][ulen] = NO;
	vec[tlen][ulen] = END;

	for (i = 0; i < tlen; i++) {		/* Ƚɤ */
		err[i][ulen] = tlen - i;
		cmp[i][ulen] = 0;
		cor[i][ulen] = NO;
		vec[i][ulen] = DRP;
	}
	for (j = 0; j < ulen; j++) {		/* Ƚɤ */
		err[tlen][j] = ulen - j;
		cmp[tlen][j] = 0;
		cor[tlen][j] = NO;
		vec[tlen][j] = INS;
	}

	for (i = tlen - 1; i >= 0; i--) {
		for (j = ulen - 1; j >= 0; j--) {
			int tmperr, tmpcmp;
			if (t[i] == u[j]) {
				tmperr = err[i+1][j+1];			/*  */
				if (cor[i+1][j+1] == OK) {
					tmpcmp = cmp[i+1][j+1];
				} else {
					tmpcmp = cmp[i+1][j+1]+1;
				}
				cor[i][j] = OK;
				vec[i][j] = COR;
			} else {
				tmperr = err[i+1][j+1]+1;		/*  */
				tmpcmp = cmp[i+1][j+1];
				cor[i][j] = NO;
				vec[i][j] = WRG;
			}
			if (t[i] == u[j+1] && t[i+1] == u[j]) {	/* ž */
				if (tmperr > err[i+2][j+2]+1 ||
					tmperr == err[i+2][j+2]+1 && tmpcmp > cmp[i+2][j+2]) {
						tmperr = err[i+2][j+2]+1;
						tmpcmp = cmp[i+2][j+2];
						cor[i][j] = NO;
						vec[i][j] = XCH;
					/* err[i+2][j+2] Ϥ֤ʤϣˡ ͤ衪 */
				}
			}
			if (tmperr > err[i][j+1]+1 ||			/*  */
				tmperr == err[i][j+1]+1 && tmpcmp > cmp[i][j+1]) {
					tmperr = err[i][j+1]+1;
					tmpcmp = cmp[i][j+1];
					cor[i][j] = NO;
					vec[i][j] = INS;
			}
			if (tmperr > err[i+1][j]+1 ||			/* æ */
				tmperr == err[i+1][j]+1 && tmpcmp > cmp[i+1][j]) {
					tmperr = err[i+1][j]+1;
					tmpcmp = cmp[i+1][j];
					cor[i][j] = NO;
					vec[i][j] = DRP;
			}
			err[i][j] = tmperr;
			cmp[i][j] = tmpcmp;
		}
	}

	errors += err[0][0];

	i = j = 0;
	while (vec[i][j] != END) {
		if (vec[i][j] & COR) {				/*  */
			putchar(u[j]); i++, j++;
		} else if (vec[i][j] & WRG) {		/*  */
			xcolor4wrong();
			printf("%c", u[j]); i++, j++;
			xcolornormal();
		} else if (vec[i][j] & INS) {		/*  */
			xcolor4inserted();
			printf("%c", u[j]); j++;
			xcolornormal();
		} else if (vec[i][j] & DRP) {		/* æ */
			xcolor4dropped();
			printf("%c", CHAR4DROPPED); i++;
			xcolornormal();
		} else if (vec[i][j] & XCH) {		/* ž */
			xcolor4xposed();
			printf("%c%c", u[j], u[j+1]); i+=2, j+=2;
			xcolornormal();
		}
	}
} /* evaluate */
