#include <stdio.h>
#include <stdlib.h>
#ifdef LINUX
#include <sys/types.h>
#include <sys/stat.h>
#else
#include <dos.h>
#include <io.h>
#endif /* LINUX */
#include "tx.h"
#include "tx2.h"


/******************************************************************************
ڴؿ̾	setscreen
ڵǽ	ץγϻ˸ƤФ̴Ϣؿ
ڰ	ʤ
͡	ʤ
******************************************************************************/
void setscreen(void) {
	xcls();

#ifdef LINUX
	cursor_off();
#else
	printf("\033[>1h");				/* ե󥯥󥭡ɽä */
	printf("\033[>5h");				/* ɽ */
#ifndef J3100
	printf("\033[>3l");				/* ԥ⡼ɤ */
#endif /* not J3100 */
#endif /* LINUX */

} /* setscreen */


/******************************************************************************
ڴؿ̾	endscreen
ڵǽ	ץνλ˸ƤФ̴Ϣؿ
ڰ	ʤ
͡	ʤ
******************************************************************************/
void endscreen(void) {
	xcls();

#ifdef LINUX
	cursor_on();
#else
	printf("\033[>1l");					/* ե󥯥󥭡ɽФ */
	printf("\033[>5l");					/* ɽ */
#endif /* LINUX */
} /* endscreen */


/******************************************************************************
ڴؿ̾	chmod_to_777
ڵǽ	եɤ߽񤭲Ĥˤ롣
ڰ	ե̾
͡	ʤ
******************************************************************************/
void chmod_to_777(char* filename) {
#ifdef LINUX
  chmod(filename, 0777);
#else
  _chmod(filename, 1, FA_NORMAL);
#endif /* LINUX */
} /* chmod_to_777 */


/******************************************************************************
ڴؿ̾	chmod_to_755
ڵǽ	ե񤭹ԲĤˤ롣
ڰ	ե̾
͡	ʤ
******************************************************************************/
void chmod_to_755(char* filename) {
#ifdef LINUX
  chmod(filename, 0755);
#else
  _chmod(filename, 1, FA_RDONLY);
#endif /* LINUX */
} /* chmod_to_755 */

