/******************************************************************************
ˤǤˡ
******************************************************************************/

#include <stdio.h>
#include <ctype.h>		/* isspace */
#include <string.h>		/* strcpy */
#include <stdlib.h>		/* malloc */
#include "tx.h"


/******************************************************************************
ڴؿ̾	skip_space
ڵǽ	ȥ꡼ζʸ򥹥åפ롣
ڰ	Figure ؤΥݥ󥿡
͡	Ȥϼɤ߹ޤ٤ʸ
			ԤȤ EOF.
			ȥ꡼νüãȤ EOF.
ա	Υȥ꡼ˤϡungetc ֤Τա
******************************************************************************/
int skip_space(FILE* in) {
	int ch;

	while ((ch=fgetc(in)) != EOF) {
		if (!isspace(ch)) {
			return ungetc(ch, in);
		}
	}
	return EOF;
} /* skip_space */


/******************************************************************************
ڴؿ̾	myfgets
ڵǽ	ȥ꡼फɤ߹ࡣ
			 '\n' ޤǤ lim ʲĹʤС'\n'  '\0'夨 buf 
			Ǽ롣EOF ޤ '\n' ʤϡιԤ lim - 1 ʲĹ
			ʤ buf ˳Ǽ롣ĹȤϡbuf ꡣ
ڰ	ɤ߹Υɥ쥹Ĺξ¡ȥ꡼ؤΥݥ󥿡
֤͡	ɤ߹ޤ줿Ȥ strlen(buf) Ʊ֤ͤĹȤ
			-1.
ա	ɤ߹ޤ줿硢buf ϥ̥ʸˤʤꡢ'\0' ľ '\n'
			Ǥʤbuf Ĺϡlim Ф褤lim ϣʾǤ뤳ȡ
******************************************************************************/
int myfgets(char *buf, int lim, FILE *in) {
	int i, c;

	for (i = 0; c = getc(in), !feof(in) && c != '\n'; i++) {
		if (i < lim - 1) {
			buf[i] = c;
		} else {
			while(!feof(in) && getc(in) != '\n') {
				;
			}
			return -1;
		}
	}
	buf[i] = '\0';
	return i;
} /* myfgets */


/******************************************************************************
ڴؿ̾	read1line
ڵǽ	ȥ꡼फԤɤ߹ߡƤƥԡ롣
ڰ	ȥ꡼ؤΥݥ󥿡
֤͡	ƤƬɥ쥹­ʤ NULL.
******************************************************************************/
char* read1line(FILE *in) {
	static char buf[256];				/* ԤκĹ 256 */
	char* p;
	int len = myfgets(buf, sizeof(buf), in);

	if (len == -1) {
		return NULL;
	} else {
		p = malloc(len+1);
		if (p == NULL) {
			return NULL;
		}
		return strcpy(p, buf);	/* p ֤ */
	}
} /* read1line */


/******************************************************************************
ڴؿ̾	copyright
ڵǽ	줿֤ɽ
ڰ	ʤ
֤͡	ʤ
******************************************************************************/
void copyright(void) {
	int i;

	xgotoxy(LINES - 1, 1);
	for (i=0; i<5; i++) {
		putchar(' ');
	}
	xprintf(copyright1);
	xclr2end();

	xgotoxy(LINES, 1);
	for (i=0; i<5; i++) {
		putchar(' ');
	}
	xprintf(copyright2);
	xclr2end();
} /* copyright */


/******************************************************************************
ڴؿ̾	drawlines
ڵǽ	ܤӲ飳ܤˡ
ڰ	ʤ
͡	ʤ
******************************************************************************/
void drawlines(void) {
	int i, j;
/*	char *lineseg = ""; */			/* 룹ʣХȾѡ */
	char *lineseg = "-";

	xgotoxy(2,1);

	for (i=0; i<8; i++) {				/*  */
		if (usrname[7-i] != ' ') {
			break;
		}
	}
	for (j=0; j<68+i; j++) {
		xprintf(lineseg);
	}
	xprintf(" %s", usrname);			/* ˥桼̾Ф */
	xgotoxy(2,79);
	xprintf(lineseg);					/* ޤ */

/*
	for (i=0; i<80; i++) {				   פʤ顢äˤ
		xprintf(lineseg);
	}
*/
	xclr2end();

	xgotoxy(LINES - 2, 1);
	for (i=0; i<80; i++) {
		xprintf(lineseg);
	}
	xclr2end();
} /* drawlines */


/******************************************************************************
ڴؿ̾	showmenu
ڵǽ	˥塼ʤʸˤɽ
ڰ	ʸؤΥݥ󥿡
͡	ʤ
ա	褻ǡ֤ɽޤ
******************************************************************************/
void showmenu(char* str) {
	xgotoxy(1, 25);
	xprintf("%54s", str);
} /* showmenu */


/******************************************************************************
ڴؿ̾	ending
ڵǽ	åФơץλ롣
ڰ	λåؤΥݥ󥿡
͡	ʤ
******************************************************************************/
void ending(char *msg, char *s) {
	endscreen();						/* ̥ꥢ */

	fprintf(stderr, "%s\n", copyright1);		/* ɽ */
	fprintf(stderr, "%s\n", copyright2);		/* ɽ */

	if (msg != NULL) {
#ifdef LINUX
		printf("TX: ");
		if (s != NULL) {
			printf(msg, s);
		} else {
			printf(msg);
		}
		putchar('\n');
#else
		fputs("TX: ", stderr);
		if (s != NULL) {
			fprintf(stderr, msg, s);
		} else {
			fprintf(stderr, msg);
		}
		fputc('\n', stderr);
#endif
	}

	exit(EXIT_SUCCESS);
} /* ending */
